diff --git a/drivers/crypto/armv8/meson.build b/drivers/crypto/armv8/meson.build
index 5effba8bbc..700fb80eb2 100644
--- a/drivers/crypto/armv8/meson.build
+++ b/drivers/crypto/armv8/meson.build
@@ -17,3 +17,4 @@ endif
 ext_deps += dep
 deps += ['bus_vdev']
 sources = files('rte_armv8_pmd.c', 'rte_armv8_pmd_ops.c')
+pmd_supports_disable_iova_as_pa = true
diff --git a/drivers/crypto/ipsec_mb/meson.build b/drivers/crypto/ipsec_mb/meson.build
index 64fc22611d..ec147d2110 100644
--- a/drivers/crypto/ipsec_mb/meson.build
+++ b/drivers/crypto/ipsec_mb/meson.build
@@ -41,3 +41,4 @@ sources = files(
         'pmd_zuc.c',
 )
 deps += ['bus_vdev', 'net', 'security']
+pmd_supports_disable_iova_as_pa = true
diff --git a/drivers/crypto/null/meson.build b/drivers/crypto/null/meson.build
index acc16e7d81..59a7508f18 100644
--- a/drivers/crypto/null/meson.build
+++ b/drivers/crypto/null/meson.build
@@ -9,3 +9,4 @@ endif
 
 deps += 'bus_vdev'
 sources = files('null_crypto_pmd.c', 'null_crypto_pmd_ops.c')
+pmd_supports_disable_iova_as_pa = true
diff --git a/drivers/crypto/openssl/meson.build b/drivers/crypto/openssl/meson.build
index cd962da1d6..d165c32ae8 100644
--- a/drivers/crypto/openssl/meson.build
+++ b/drivers/crypto/openssl/meson.build
@@ -15,3 +15,4 @@ endif
 deps += 'bus_vdev'
 sources = files('rte_openssl_pmd.c', 'rte_openssl_pmd_ops.c')
 ext_deps += dep
+pmd_supports_disable_iova_as_pa = true
diff --git a/drivers/dma/skeleton/meson.build b/drivers/dma/skeleton/meson.build
index 8871b80956..2b0422ce61 100644
--- a/drivers/dma/skeleton/meson.build
+++ b/drivers/dma/skeleton/meson.build
@@ -5,3 +5,4 @@ deps += ['dmadev', 'kvargs', 'ring', 'bus_vdev']
 sources = files(
         'skeleton_dmadev.c',
 )
+pmd_supports_disable_iova_as_pa = true
diff --git a/drivers/event/dsw/meson.build b/drivers/event/dsw/meson.build
index 2df0fac4ff..e6808c0f71 100644
--- a/drivers/event/dsw/meson.build
+++ b/drivers/event/dsw/meson.build
@@ -6,3 +6,4 @@ if cc.has_argument('-Wno-format-nonliteral')
     cflags += '-Wno-format-nonliteral'
 endif
 sources = files('dsw_evdev.c', 'dsw_event.c', 'dsw_xstats.c')
+pmd_supports_disable_iova_as_pa = true
diff --git a/drivers/event/opdl/meson.build b/drivers/event/opdl/meson.build
index 786d2f4e82..7abef44609 100644
--- a/drivers/event/opdl/meson.build
+++ b/drivers/event/opdl/meson.build
@@ -9,3 +9,4 @@ sources = files(
         'opdl_test.c',
 )
 deps += ['bus_vdev']
+pmd_supports_disable_iova_as_pa = true
diff --git a/drivers/event/skeleton/meson.build b/drivers/event/skeleton/meson.build
index acfe156532..fa6a5e0a9f 100644
--- a/drivers/event/skeleton/meson.build
+++ b/drivers/event/skeleton/meson.build
@@ -3,3 +3,4 @@
 
 sources = files('skeleton_eventdev.c')
 deps += ['bus_pci', 'bus_vdev']
+pmd_supports_disable_iova_as_pa = true
diff --git a/drivers/event/sw/meson.build b/drivers/event/sw/meson.build
index 6f81567efb..8d815dfa84 100644
--- a/drivers/event/sw/meson.build
+++ b/drivers/event/sw/meson.build
@@ -9,3 +9,4 @@ sources = files(
         'sw_evdev.c',
 )
 deps += ['hash', 'bus_vdev']
+pmd_supports_disable_iova_as_pa = true
diff --git a/drivers/mempool/bucket/meson.build b/drivers/mempool/bucket/meson.build
index 0051b6ac3c..94c060904b 100644
--- a/drivers/mempool/bucket/meson.build
+++ b/drivers/mempool/bucket/meson.build
@@ -12,3 +12,4 @@ if is_windows
 endif
 
 sources = files('rte_mempool_bucket.c')
+pmd_supports_disable_iova_as_pa = true
diff --git a/drivers/mempool/ring/meson.build b/drivers/mempool/ring/meson.build
index a021e908cf..65d203d4b7 100644
--- a/drivers/mempool/ring/meson.build
+++ b/drivers/mempool/ring/meson.build
@@ -2,3 +2,4 @@
 # Copyright(c) 2017 Intel Corporation
 
 sources = files('rte_mempool_ring.c')
+pmd_supports_disable_iova_as_pa = true
diff --git a/drivers/mempool/stack/meson.build b/drivers/mempool/stack/meson.build
index 580dde79eb..961e90fc04 100644
--- a/drivers/mempool/stack/meson.build
+++ b/drivers/mempool/stack/meson.build
@@ -4,3 +4,4 @@
 sources = files('rte_mempool_stack.c')
 
 deps += ['stack']
+pmd_supports_disable_iova_as_pa = true
diff --git a/drivers/net/af_packet/meson.build b/drivers/net/af_packet/meson.build
index c014e9b61b..bab008d083 100644
--- a/drivers/net/af_packet/meson.build
+++ b/drivers/net/af_packet/meson.build
@@ -6,3 +6,4 @@ if not is_linux
     reason = 'only supported on Linux'
 endif
 sources = files('rte_eth_af_packet.c')
+pmd_supports_disable_iova_as_pa = true
diff --git a/drivers/net/af_xdp/meson.build b/drivers/net/af_xdp/meson.build
index 1e0de23705..7bbab52d8b 100644
--- a/drivers/net/af_xdp/meson.build
+++ b/drivers/net/af_xdp/meson.build
@@ -55,3 +55,5 @@ else
     build = false
     reason = 'missing header, "linux/if_xdp.h"'
 endif
+
+pmd_supports_disable_iova_as_pa = true
diff --git a/drivers/net/bonding/meson.build b/drivers/net/bonding/meson.build
index 18ad7e21f3..29022712cb 100644
--- a/drivers/net/bonding/meson.build
+++ b/drivers/net/bonding/meson.build
@@ -22,3 +22,4 @@ deps += 'sched' # needed for rte_bitmap.h
 deps += ['ip_frag']
 
 headers = files('rte_eth_bond.h', 'rte_eth_bond_8023ad.h')
+pmd_supports_disable_iova_as_pa = true
diff --git a/drivers/net/failsafe/meson.build b/drivers/net/failsafe/meson.build
index b8e5bf70f8..bf8f791984 100644
--- a/drivers/net/failsafe/meson.build
+++ b/drivers/net/failsafe/meson.build
@@ -27,3 +27,4 @@ sources = files(
         'failsafe_ops.c',
         'failsafe_rxtx.c',
 )
+pmd_supports_disable_iova_as_pa = true
diff --git a/drivers/net/memif/meson.build b/drivers/net/memif/meson.build
index 680bc8631c..28416a982f 100644
--- a/drivers/net/memif/meson.build
+++ b/drivers/net/memif/meson.build
@@ -12,3 +12,4 @@ sources = files(
 )
 
 deps += ['hash']
+pmd_supports_disable_iova_as_pa = true
diff --git a/drivers/net/null/meson.build b/drivers/net/null/meson.build
index 0251578aab..4a483955a7 100644
--- a/drivers/net/null/meson.build
+++ b/drivers/net/null/meson.build
@@ -8,3 +8,4 @@ if is_windows
 endif
 
 sources = files('rte_eth_null.c')
+pmd_supports_disable_iova_as_pa = true
diff --git a/drivers/net/pcap/meson.build b/drivers/net/pcap/meson.build
index ed7864eb9d..a5a2971f0e 100644
--- a/drivers/net/pcap/meson.build
+++ b/drivers/net/pcap/meson.build
@@ -15,3 +15,4 @@ ext_deps += pcap_dep
 if is_windows
     ext_deps += cc.find_library('iphlpapi', required: true)
 endif
+pmd_supports_disable_iova_as_pa = true
diff --git a/drivers/net/ring/meson.build b/drivers/net/ring/meson.build
index 0156b37aad..72792e26b0 100644
--- a/drivers/net/ring/meson.build
+++ b/drivers/net/ring/meson.build
@@ -9,3 +9,4 @@ endif
 
 sources = files('rte_eth_ring.c')
 headers = files('rte_eth_ring.h')
+pmd_supports_disable_iova_as_pa = true
diff --git a/drivers/net/tap/meson.build b/drivers/net/tap/meson.build
index c09713a67b..4c9a9eac2b 100644
--- a/drivers/net/tap/meson.build
+++ b/drivers/net/tap/meson.build
@@ -35,3 +35,4 @@ foreach arg:args
     config.set(arg[0], cc.has_header_symbol(arg[1], arg[2]))
 endforeach
 configure_file(output : 'tap_autoconf.h', configuration : config)
+pmd_supports_disable_iova_as_pa = true
diff --git a/drivers/raw/skeleton/meson.build b/drivers/raw/skeleton/meson.build
index 950a33cc20..bfb8fd8bcc 100644
--- a/drivers/raw/skeleton/meson.build
+++ b/drivers/raw/skeleton/meson.build
@@ -6,3 +6,4 @@ sources = files(
         'skeleton_rawdev.c',
         'skeleton_rawdev_test.c',
 )
+pmd_supports_disable_iova_as_pa = true